package com.ahs.flutter.ahs_flutter_router

import android.content.Context
import com.ahs.flutter.ahs_flutter_router.channel.eventchannel.EventChannelManager
import com.ahs.flutter.ahs_flutter_router.channel.eventchannel.EventChannelBuilder
import com.ahs.flutter.ahs_flutter_router.channel.methodchannel.MethodChannelManager
import com.ahs.flutter.ahs_flutter_router.channel.methodchannel.MethodChannelBuilder
import com.ahs.flutter.ahs_flutter_router.intent.FlutterModuleIntentManager
import com.ahs.flutter.ahs_flutter_router.intent.ModuleIntentBuilder

/**
 * AHS Flutter Router 插件的入口
 */
object AhsRouterManager {

    /***
     * 初始化路由插件
     *  moduleIntentBuilder 提供页面跳转路由
     *  moduleMethodChannelBuilder 提供自定义 methodChannel 通信
     *  moduleEventChannelBuilder 提供自定义 EventChannel 通信
     */
    fun init(
        context: Context,
        intentBuilder: ModuleIntentBuilder,
        methodChannelBuilder: MethodChannelBuilder?=null,
        eventChannelBuilder: EventChannelBuilder? =null
    ) {
        FlutterModuleIntentManager.init(intentBuilder)
        if (methodChannelBuilder!=null){
            MethodChannelManager.init(methodChannelBuilder)
        }
        if (eventChannelBuilder!=null){
            EventChannelManager.init(eventChannelBuilder)
        }
    }
}