package com.ahs.flutter.ahs_flutter_router

import android.app.Activity
import android.content.Context
import io.flutter.embedding.android.FlutterActivity

/**
 * 跳转到Flutter页面的控制类
 * */
object FlutterRouter {

    /**
     * 跳转到Flutter的pageScreen页面传递参数
     */
    fun startFlutterScreen(context: Context, pageScreen: String, param: HashMap<String, Any>) {
        val uri = mapToUri(pageScreen, param)
        context.startActivity(
            FlutterActivity
                .withNewEngine()
                .initialRoute(uri)
                .build(context)
        )
    }

    /**
     *  跳转到Flutter的pageScreen页面传递参数带返回参数的
     */
    fun startFlutterScreenForResult(
        context: Activity,
        pageScreen: String,
        param: HashMap<String, Any>
    ) {
        val uri = mapToUri(pageScreen, param)
        val intent = FlutterActivity
            .withNewEngine()
            .initialRoute(uri)
            .build(context)
        context.startActivityForResult(intent, Activity.RESULT_FIRST_USER)
    }

    /**
     * 参数转URI
     */
    private fun mapToUri(pageScreen: String, map: MutableMap<String, Any>): String {
        var param = ""
        for ((key, value) in map) {
            param = "$param$key=$value&"
        }
        var params = param.substring(0, param.length - 1)
        return "$pageScreen?$params"

    }

}