package com.ahs.flutter.ahs_flutter_router.channel.eventchannel

import android.util.Log
import com.ahs.flutter.ahs_flutter_router.channel.FlutterBinaryMessenger
import io.flutter.plugin.common.EventChannel

/**
 * 初始化 Flutter 和原生通信的自定义 channel
 */
object EventChannelManager {


    lateinit var moduleEventChannelBuilder: EventChannelBuilder

    /**
     * 应用初始化的时候调用
     */
    fun init(ModuleEventChannelBuilder: EventChannelBuilder) {
        moduleEventChannelBuilder = ModuleEventChannelBuilder

    }

    fun initEventChannel() {
        val eventChannelName = moduleEventChannelBuilder.getEventChannelName()
        if (eventChannelName.isNullOrEmpty()) {
            Log.e(EventChannelManager.javaClass.name, "eventChannelName")
            return
        }
        val eventChannel =
            EventChannel(FlutterBinaryMessenger.weakReference.get(), eventChannelName)

        eventChannel.setStreamHandler(object : EventChannel.StreamHandler {
            override fun onListen(arguments: Any?, events: EventChannel.EventSink?) {
                moduleEventChannelBuilder.onListen(arguments, events)
            }

            override fun onCancel(arguments: Any?) {
                moduleEventChannelBuilder.onCancel(arguments)
            }
        })
    }
}