package com.ahs.flutter.ahs_flutter_router.channel.methodchannel

import android.util.Log
import com.ahs.flutter.ahs_flutter_router.channel.FlutterBinaryMessenger
import io.flutter.plugin.common.MethodChannel

/**
 * 初始化 Flutter 和原生通信的自定义 channel
 */
object MethodChannelManager {


    private lateinit var mModuleMethodChannelBuilder: MethodChannelBuilder
    /**
     * 应用初始化的时候调用
     */
    fun init(moduleMethodChannelBuilder: MethodChannelBuilder) {
        mModuleMethodChannelBuilder = moduleMethodChannelBuilder
    }



    fun initMethodChannel(){
        val methodChannelName = mModuleMethodChannelBuilder.getMethodChannelName()
        if (methodChannelName.isNullOrEmpty()){
            Log.e(MethodChannelManager.javaClass.name,"自定义methodChannelName不能为空")
            return
        }
        val methodChannel =
            MethodChannel(FlutterBinaryMessenger.weakReference.get(), methodChannelName)

        methodChannel.setMethodCallHandler { call, result ->
            run {
                mModuleMethodChannelBuilder.onMethodCall(call, result)
            }
        }
    }
}