import 'dart:async';
import 'package:ahs_flutter_router/utils/env_util.dart';
import 'package:flutter/services.dart';
import 'ahs_router_constant.dart';

///路由插件提供的channel
class AhsFlutterRouter {
  static const MethodChannel _channel =
  const MethodChannel(AhsRouterConstant.routerChannelName);
  
  //跳转到原生界面并传递参数
  static Future<String> toNativeByParam(Map<String, dynamic> param) async {
    await _channel.invokeMethod(AhsRouterConstant.flutterToNative, param);
  }

  static Future<String> returnLastNativePage(Map<String, dynamic> param) async {
    final String result =
    await _channel.invokeMethod(AhsRouterConstant.backNativePage, param);
    if (EnvUtil.getCompileMode() == "debug") {
      print("flutterLog-----------返回上个原生界面界面" + result);
    }
  }

  
  static String paramToUrl(String pageScreen, Map<String, dynamic> map) {
    var param = "";
    map.forEach((k, v) => {param = param + k + "=" + v});
    var params = param.substring(0, param.length - 1);
    print("paramToUrl----------- " + pageScreen + "?" + params);
    return pageScreen + "?" + params;
  }
}
